#!/bin/sh

#
# Copyright (c) 2008 plumber <OpenSpecies@gnu-darwin.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

#
#  rtool
#  rtool - relocation tool.
#
#  Created by plumber on 01/01/03.
#  Copyright 2008 OpenSpecies. All rights reserved.
#
#

echo "-> building libfoo.dylib --"
gcc -dynamiclib libfoo.c -install_name "libfoo.dylib" -o libfoo.dylib

echo "-> building bar.dylib --"
gcc -dynamiclib libbar.c -install_name "@executable_path/libbar.dylib" -o libbar.dylib

echo "-> building main --"
gcc main.c -o main -L. -lfoo -lbar

echo "-> testing binary:: Library not loaded: libfoo.dylib --"

(cd .. && ./dyld/main)

echo ""

echo "-> exporting dyld dir in DYLD_LIBRARY_PATH"

export DYLD_LIBRARY_PATH="dyld:$DYLD_LIBRARY_PATH"

echo "-> testing binary:: loaded libfoo.dylib--"

(cd .. && ./dyld/main)

otool -L main
otool -L libbar.dylib
otool -L libfoo.dylib

rm -f main libfoo.dylib libbar.dylib

#EOF