#!/bin/sh

#
# Copyright (c) 2008 plumber <OpenSpecies@gnu-darwin.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

#
#  rtool
#  rtool - relocation tool.
#
#  Created by plumber on 01/01/03.
#  Copyright 2008 OpenSpecies. All rights reserved.
#
#

echo "-> building libutil.dylib --"
gcc -dynamiclib libutil.c -install_name "@executable_path/libutil.dylib" -o libutil.dylib -framework CoreFoundation

echo "-> building libbar.dylib --"
gcc -dynamiclib libbar.c -install_name "@executable_path/libbar.dylib" -o libbar.dylib -L. -lutil

echo "-> building libfoo.dylib --"
gcc -dynamiclib libfoo.c -install_name "@executable_path/libfoo.dylib" -o libfoo.dylib -L. -lbar -lutil

echo "-> building main --"
gcc main.c -o main -L. -lfoo -lbar -lutil

echo "-> testing binaries --"

bins="main libfoo.dylib libbar.dylib libutil.dylib"

for bin in $bins; do
	
	echo "## from" $(dirname $bin) "--"
	echo "###" $(basename $bin) 
	otool -LX $bin | awk '{print $1}'
	echo ""
	
done

echo "-> executing main from . --"

./main

echo "-> executing main from $(pwd) --"

$(pwd)/main

rm -f main libfoo.dylib libbar.dylib libutil.dylib